/**
 *
 *   8    .
 * ,     20,
 *    1  2 .
 *
 *  ATMega16(32)    16 .  
 *    A.
 *
 *  8- ,     .
 *   160 ,  10. 
 *
 *    100 ,   ,
 *     100 .  ,    ,
 *    ,   
 * ,    .
 *
 */



#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>


/**
 * ,    .      10 ,
 *          ,
 *   10,  100 (100 * 10 =1000, ..  
 * ). 50   , 0  100  .
 **/
uint8_t servo_position[8] = {0, 0, 0, 0, 0, 0, 0, 100, };

/**
 *   
 */
uint8_t table[100];

/**
 *    .
 */
uint8_t flag = 1;



/**
 *   
 */
SIGNAL(SIG_OUTPUT_COMPARE0)
{
	/**
	 *  . 
	 **/
	static uint16_t counter = 0;
	/*   OCR0,      160  */
	OCR0 += 160;
	/*   */
	counter++;
	if (counter == 200) {
		/*    200, ,  2 ,    
		 * .   ,   ,
		 *       ,   . */
		PORTA = 0;
		flag = 1;
	} else if (counter > 99 && counter < 200) {
		/*     99  200 -    
		 *    . */
		PORTA = table[counter-100];
	} else if (counter == 2000) {
		/*  20.     , 
		 *     1   . */
		counter = 0;
		PORTA = 0xFF;
	}
}

/**
 *   .
 */
void fill_table(void)
{
	uint8_t i, j;
	/*     */
	memset(table, 0xFF, 100);
	/*   ,     , 
	 *  ,    . ,  
	 *    0  1200 ,      19  99
	 *  0   */
	for (i = 0; i < 8; i++) {
		for (j = servo_position[i]; j < 100; j++) {
			table[j] &= ~(1 << i);
		} 
	}
}

volatile uint32_t i;

int main(void)
{
	DDRA = 0xFF;
	TCCR0 = _BV(CS00);  /*      */
	TIMSK = _BV(OCIE0); /*     */
	sei();				/*   */

	/*    .     
	 *     .
	 *         - ,
	 *       ( ,    15),
	 *       
	 *   . */
	for(;;)  {
		i++;
		if (flag) {
			fill_table();
			flag = 0;
		}
	}
}
